#-*- coding: utf-8 -*-
#
# Système de gestion des adhésions de Nos oignons
# Copyright © 2013-2014 Nos oignons <contact@nos-oignons.net>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'shellwords'

module NosOignons
  module Mailman
    class << self
      def list_members(list)
        `sudo -u list list_members #{Shellwords.escape(list)}`.strip.split
      end

      def add_member(list, email)
        add_members(list, [email])
      end

      def add_members(list, emails)
        IO.popen(['sudo', '-u', 'list', 'add_members', '-r', '-', list], 'w') do |io|
          emails.each do |email|
            io.puts email
          end
        end
      end

      def remove_member(list, email)
        remove_members(list, [email])
      end

      def remove_members(list, emails)
        IO.popen(['sudo', '-u', 'list', 'remove_members', '-f', '-', list], 'w') do |io|
          emails.each do |email|
            io.puts email
          end
        end
      end
    end
  end
end
